# Opting Staking

![Flowchart](/files/KghugoL9IdsI2kXMj6H0)

The difference between single-asset and LP staking is that the goal of LP Staking is to improve the liquidity of a DeFi protocol, whereas single-asset staking underlines the importance of a blockchain network's security.&#x20;

The rewards in single-asset staking is based on Annual Percentage Yield (APY) whereas in LP staking the rewards are calculated in terms of amount of token staked and the liquidity of the pool.

#### Mandatory attricbutes

To get staking for your token, you'll need to give us with a few pieces of information so that our tech team can create a unique smart contract that meets your needs.

1. Single-asset staking: **total APY , rewardToken** (token to be rewarded), **stakeToken** (token to be staked), **contract owner address** (the address of the smart contract owner).&#x20;
2. LP staking: **rewardToken** (token to be rewarded), **stakeToken** (token to be staked), **contract owner address** (the smart contract owner's address), **totalReward** (total reward calculated according to the smart contract's formula), **startBlock** (block from which staking begins), **endBlock**  ( block at which the staking ends).

#### Optional attributes

![Optional data](/files/rmotzvcGo7u1419GnkNb)

The flowchart above describes the optional attributes that can be incorporated into the smart contract for more optimized staking program.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.propel.xyz/products/decentralised-finance/staking/opting-staking.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
